data {
    int N;
    int M;
    int<lower = 1, upper = 3> X[N, M];
}
transformed data {
    real C1;
    real C2;
    C1 = -1;
    C2 = 1;
}
parameters {
    real mu[M];
    real<lower = 0.0> Lmd[M];
    real<lower = 0.0> psy[M];
    real F[N];
}
transformed parameters {
    vector[3] p[N, M];
    real cumP[N, M];
    for (i in 1:N)
        for (j in 1:M){
            cumP[i][j] = normal_cdf((C2 - (mu[j] + Lmd[j] * F[i])) / psy[j], 0.0, 1.0);
            p[i][j][1] = normal_cdf((C1 - (mu[j] + Lmd[j] * F[i])) / psy[j], 0.0, 1.0);
            p[i][j][2] = cumP[i][j] - p[i][j][1];
            p[i][j][3] = 1.0 - cumP[i][j];
        }
    
}
model {
    for (j in 1:M) {
        mu[j] ~ normal(0.0, 100.0);
        psy[j] ~ exponential(0.01);
        Lmd[j] ~ exponential(0.01);
    }
    for (i in 1:N) {
        F[i] ~ normal(0.0, 1.0);
    }
    for (i in 1:N) {
        for (j in 1:M) {
            X[i][j] ~ categorical(p[i][j]);
        }
    }
}
